[BACK]Return to mkdep.gcc.sh CVS log [TXT][DIR] Up to [local] / src / usr.bin / mkdep

Annotation of src/usr.bin/mkdep/mkdep.gcc.sh, Revision 1.11

1.1       deraadt     1: #!/bin/sh -
                      2: #
1.11    ! pvalchev    3: #      $OpenBSD: mkdep.gcc.sh,v 1.10 2000/07/23 22:22:07 millert Exp $
1.1       deraadt     4: #      $NetBSD: mkdep.gcc.sh,v 1.9 1994/12/23 07:34:59 jtc Exp $
                      5: #
                      6: # Copyright (c) 1991, 1993
                      7: #      The Regents of the University of California.  All rights reserved.
                      8: #
                      9: # Redistribution and use in source and binary forms, with or without
                     10: # modification, are permitted provided that the following conditions
                     11: # are met:
                     12: # 1. Redistributions of source code must retain the above copyright
                     13: #    notice, this list of conditions and the following disclaimer.
                     14: # 2. Redistributions in binary form must reproduce the above copyright
                     15: #    notice, this list of conditions and the following disclaimer in the
                     16: #    documentation and/or other materials provided with the distribution.
                     17: # 3. All advertising materials mentioning features or use of this software
                     18: #    must display the following acknowledgement:
                     19: #      This product includes software developed by the University of
                     20: #      California, Berkeley and its contributors.
                     21: # 4. Neither the name of the University nor the names of its contributors
                     22: #    may be used to endorse or promote products derived from this software
                     23: #    without specific prior written permission.
                     24: #
                     25: # THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
                     26: # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
                     27: # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
                     28: # ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
                     29: # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
                     30: # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
                     31: # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
                     32: # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
                     33: # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
                     34: # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
                     35: # SUCH DAMAGE.
                     36: #
                     37: #      @(#)mkdep.gcc.sh        8.1 (Berkeley) 6/6/93
                     38: #
                     39:
                     40: D=.depend                      # default dependency file is .depend
                     41: append=0
                     42: pflag=
                     43:
                     44: while :
                     45:        do case "$1" in
                     46:                # -a appends to the depend file
                     47:                -a)
                     48:                        append=1
                     49:                        shift ;;
                     50:
                     51:                # -f allows you to select a makefile name
                     52:                -f)
                     53:                        D=$2
                     54:                        shift; shift ;;
                     55:
                     56:                # the -p flag produces "program: program.c" style dependencies
                     57:                # so .o's don't get produced
                     58:                -p)
                     59:                        pflag=p
                     60:                        shift ;;
                     61:                *)
                     62:                        break ;;
                     63:        esac
                     64: done
                     65:
                     66: if [ $# = 0 ] ; then
                     67:        echo 'usage: mkdep [-p] [-f depend_file] [cc_flags] file ...'
                     68:        exit 1
                     69: fi
                     70:
1.3       deraadt    71: um=`umask`
                     72: umask 022
1.11    ! pvalchev   73:
        !            74: TMP=`mktemp /tmp/mkdep.XXXXXXXXXX` || exit 1
1.7       deraadt    75:
1.3       deraadt    76: umask $um
1.11    ! pvalchev   77: trap 'rm -f $TMP ; trap 2 ; kill -2 $$' 1 2 3 13 15
1.1       deraadt    78:
                     79: if [ x$pflag = x ]; then
1.6       niklas     80:        ${CC:-cc} -M "$@" | sed -e 's; \./; ;g' > $TMP
1.1       deraadt    81: else
1.9       d          82:        ${CC:-cc} -M "$@" | sed -e 's;\.o[ ]*:; :;' -e 's; \./; ;g' > $TMP
1.1       deraadt    83: fi
                     84:
                     85: if [ $? != 0 ]; then
                     86:        echo 'mkdep: compile failed.'
1.11    ! pvalchev   87:        rm -f $TMP
1.1       deraadt    88:        exit 1
                     89: fi
                     90:
                     91: if [ $append = 1 ]; then
                     92:        cat $TMP >> $D
1.7       deraadt    93:        if [ $? != 0 ]; then
                     94:                echo 'mkdep: append failed.'
1.11    ! pvalchev   95:                rm -f $TMP
1.7       deraadt    96:                exit 1
                     97:        fi
1.1       deraadt    98: else
1.10      millert    99:        mv -f $TMP $D
1.7       deraadt   100:        if [ $? != 0 ]; then
                    101:                echo 'mkdep: rename failed.'
1.11    ! pvalchev  102:                rm -f $TMP
1.7       deraadt   103:                exit 1
                    104:        fi
1.1       deraadt   105: fi
1.7       deraadt   106:
1.11    ! pvalchev  107: rm -f $TMP
1.1       deraadt   108: exit 0